/* openca/pkicrypto/url.h */
/*
 * LIBPKI - OpenSource PKI library
 * by Massimiliano Pala (madwolf@openca.org) and OpenCA project
 *
 * Copyright (c) 2001-2007 The OpenCA Project.  All rights reserved.
 *
 * ====================================================================
 *
 * This product includes cryptographic software written by Eric Young
 * (eay@cryptsoft.com).  This product includes software written by Tim
 * Hudson (tjh@cryptsoft.com).
 *
 */


#ifndef _OPENCA_OCSP_URL_H
#define _OPENCA_OCSP_URL_H

#define URI_PROTO_FILE			0
#define URI_PROTO_LDAP			1
#define URI_PROTO_HTTP			2
#define URI_PROTO_FTP			3
#define URI_PROTO_MYSQL			10
#define URI_PROTO_POSTGRESQL		11

#define DEFAULT_LDAP_PORT		389
#define DEFAULT_HTTP_PORT		80
#define DEFAULT_FTP_PORT		21
#define DEFAULT_MYSQL_PORT		3306
#define DEFAULT_POSTGRESQL_PORT		3456

typedef struct url_data
	{
		/* Protocol, currently supported LDAP and FILE */
		int proto;

		/* Address or filename */
		char *addr;

		/* Communication Port (where supported by the protocol) */
		int port;

		/* Authentication (where supported by the protocol) */
		char *usr;
		char *pwd;

		/* LDAP specific */
		char *dn;
		char *attr;

		/* HTTP specific */
		char *path;
	} URL;

#define BUFF_MAX_SIZE	8192

/* Function prototypes */
int URL_free ( URL *url );
URL *URL_new ( char *url );

#define getParsedUrl( a ) URL_new ( a )

#endif
